import { CodeMirror6 } from 'https://testingcf.jsdelivr.net/npm/@bhsd/codemirror-mediawiki@2.1.1/dist/main.min.js';
(() => {
    var _a;
    mw.loader.load('https://testingcf.jsdelivr.net/npm/@bhsd/codemirror-mediawiki@2.1.1/mediawiki.min.css', 'text/css');
    const instances = new WeakMap();
    $.valHooks['textarea'] = {
        get(elem) {
            const cm = instances.get(elem);
            return (cm === null || cm === void 0 ? void 0 : cm.visible) ? cm.view.state.doc.toString() : elem.value;
        },
        set(elem, value) {
            const cm = instances.get(elem);
            if (cm === null || cm === void 0 ? void 0 : cm.visible) {
                cm.view.dispatch({
                    changes: { from: 0, to: cm.view.state.doc.length, insert: value },
                });
            }
            else {
                elem.value = value;
            }
        },
    };
    function getCaretPosition(option) {
        const { view: { state: { selection: { main } } } } = instances.get(this[0]);
        return (option === null || option === void 0 ? void 0 : option.startAndEnd) ? [main.from, main.to] : main.head;
    }
    const textSelection = {
        getContents() {
            return instances.get(this[0]).view.state.doc.toString();
        },
        setContents(content) {
            const { view } = instances.get(this[0]);
            view.dispatch({
                changes: { from: 0, to: view.state.doc.length, insert: content },
            });
            return this;
        },
        getSelection() {
            const { view: { state } } = instances.get(this[0]);
            return state.sliceDoc(state.selection.main.from, state.selection.main.to);
        },
        setSelection({ start, end }) {
            const { view } = instances.get(this[0]);
            view.dispatch({
                selection: { anchor: start, head: end !== null && end !== void 0 ? end : start },
            });
            view.focus();
            return this;
        },
        replaceSelection(value) {
            const { view } = instances.get(this[0]);
            view.dispatch(view.state.replaceSelection(value));
            return this;
        },
        getCaretPosition,
        scrollToCaretPosition() {
            instances.get(this[0]).view.dispatch({ scrollIntoView: true });
            return this;
        },
    };
    const USING_LOCAL = mw.loader.getState('ext.CodeMirror') !== null, DATA_MODULE = mw.loader.getState('ext.CodeMirror.data') ? 'ext.CodeMirror.data' : 'ext.CodeMirror', ALL_SETTINGS_CACHE = (_a = JSON.parse(localStorage.getItem('InPageEditMwConfig'))) !== null && _a !== void 0 ? _a : {}, SITE_ID = `${mw.config.get('wgServerName')}${mw.config.get('wgScriptPath')}`, SITE_SETTINGS = ALL_SETTINGS_CACHE[SITE_ID], EXPIRED = !(SITE_SETTINGS && SITE_SETTINGS.time > Date.now() - 86400 * 1000 * 30);
    const getAliases = (words) => words.flatMap(({ aliases, name }) => aliases.map(alias => ({ alias, name })));
    const getConfig = (aliases) => {
        const config = {};
        for (const { alias, name } of aliases) {
            config[alias.replace(/:$/u, '')] = name;
        }
        return config;
    };
    const getMwConfig = async () => {
        if (USING_LOCAL && EXPIRED) {
            await mw.loader.using(DATA_MODULE);
        }
        let config = mw.config.get('extCodeMirrorConfig');
        if (!config && !EXPIRED) {
            ({ config } = SITE_SETTINGS);
            mw.config.set('extCodeMirrorConfig', config);
        }
        const isIPE = config && Object.values(config.functionSynonyms[0]).includes(true);
        if (config && config.img && config.variants && !isIPE) {
            return {
                ...config,
                nsid: mw.config.get('wgNamespaceIds'),
            };
        }
        const { query: { general: { variants }, magicwords, extensiontags, functionhooks, variables }, } = await new mw.Api().get({
            meta: 'siteinfo',
            siprop: [
                'general',
                'magicwords',
                ...config && !isIPE ? [] : ['extensiontags', 'functionhooks', 'variables'],
            ],
            formatversion: '2',
        });
        const otherMagicwords = new Set(['msg', 'raw', 'msgnw', 'subst', 'safesubst']);
        if (config && !isIPE) {
            const { functionSynonyms: [insensitive] } = config;
            if (!('subst' in insensitive)) {
                const aliases = getAliases(magicwords.filter(({ name }) => otherMagicwords.has(name)));
                for (const { alias, name } of aliases) {
                    insensitive[alias.replace(/:$/u, '')] = name;
                }
            }
        }
        else {
            config = {
                tagModes: {
                    ref: 'text/mediawiki',
                },
                tags: {},
                urlProtocols: mw.config.get('wgUrlProtocols'),
            };
            for (const tag of extensiontags) {
                config.tags[tag.slice(1, -1)] = true;
            }
            const realMagicwords = new Set([
                ...functionhooks,
                ...variables,
                ...otherMagicwords,
            ]), allMagicwords = magicwords.filter(({ name, aliases }) => aliases.some(alias => /^__.+__$/u.test(alias)) || realMagicwords.has(name)), sensitive = getAliases(allMagicwords.filter(word => word['case-sensitive'])), insensitive = getAliases(allMagicwords.filter(word => !word['case-sensitive'])).map(({ alias, name }) => ({ alias: alias.toLowerCase(), name }));
            config.doubleUnderscore = [
                getConfig(insensitive.filter(({ alias }) => /^__.+__$/u.test(alias))),
                getConfig(sensitive.filter(({ alias }) => /^__.+__$/u.test(alias))),
            ];
            config.functionSynonyms = [
                getConfig(insensitive.filter(({ alias }) => !/^__.+__|^#$/u.test(alias))),
                getConfig(sensitive.filter(({ alias }) => !/^__.+__|^#$/u.test(alias))),
            ];
        }
        config.img = getConfig(getAliases(magicwords.filter(({ name }) => name.startsWith('img_'))));
        config.variants = variants ? variants.map(({ code }) => code) : [];
        config.nsid = mw.config.get('wgNamespaceIds');
        mw.config.set('extCodeMirrorConfig', config);
        ALL_SETTINGS_CACHE[SITE_ID] = { config: config, time: Date.now() };
        localStorage.setItem('InPageEditMwConfig', JSON.stringify(ALL_SETTINGS_CACHE));
        return config;
    };
    const linters = {};
    class CodeMirror extends CodeMirror6 {
        constructor(textarea, lang, config) {
            super(textarea, lang, config);
            this.visible = true;
            instances.set(textarea, this);
            if (mw.loader.getState('jquery.textSelection') === 'ready') {
                $(textarea).data('jquery.textSelection', textSelection);
            }
        }
        toggle(show = !this.visible) {
            if (show && !this.visible) {
                this.view.dispatch({
                    changes: { from: 0, to: this.view.state.doc.length, insert: this.textarea.value },
                });
            }
            this.visible = show;
            this.view.dom.style.setProperty('display', show ? '' : 'none', 'important');
            this.textarea.style.display = show ? 'none' : '';
            $(this.textarea).data('jquery.textSelection', show && textSelection);
        }
        async defaultLint(on) {
            if (!on) {
                this.lint();
                return;
            }
            const { lang } = this;
            if (!(lang in linters)) {
                linters[lang] = await this.getLinter();
                if (this.lang === 'mediawiki' || this.lang === 'html') {
                    const mwConfig = await getMwConfig(), config = {
                        ...await wikiparse.getConfig(),
                        ext: Object.keys(mwConfig.tags),
                        namespaces: mw.config.get('wgFormattedNamespaces'),
                        nsid: mw.config.get('wgNamespaceIds'),
                        doubleUnderscore: mwConfig.doubleUnderscore.map(obj => Object.keys(obj).map(s => s.slice(2, -2))),
                        variants: mwConfig.variants,
                        protocol: mwConfig.urlProtocols.replace(/\\:/gu, ':'),
                    };
                    [config.parserFunction[0]] = mwConfig.functionSynonyms;
                    config.parserFunction[1] = [
                        ...Object.keys(mwConfig.functionSynonyms[1]),
                        '=',
                    ];
                    for (const key of Object.keys(mwConfig.img)) {
                        config.img[key] = mwConfig.img[key].slice(4);
                    }
                    wikiparse.setConfig(config);
                }
            }
            this.lint(linters[lang]);
        }
        static async fromTextArea(textarea, lang) {
            const isWiki = lang === 'mediawiki' || lang === 'html', cm = new CodeMirror(textarea, isWiki ? undefined : lang);
            if (isWiki) {
                const config = await getMwConfig();
                cm.setLanguage(lang, config);
            }
            return cm;
        }
    }
    document.body.addEventListener('click', e => {
        if (e.target instanceof HTMLTextAreaElement && (e.ctrlKey || e.metaKey) && !instances.has(e.target)) {
            e.preventDefault();
            (async () => {
                var _a;
                const { wgAction, wgNamespaceNumber, wgPageContentModel } = mw.config.get();
                let lang;
                if (wgAction !== 'edit' && wgAction !== 'submit') {
                    await mw.loader.using('oojs-ui-windows');
                    lang = (_a = (await OO.ui.prompt('Language:') || undefined)) === null || _a === void 0 ? void 0 : _a.toLowerCase();
                }
                else {
                    switch (wgPageContentModel) {
                        case 'css':
                        case 'sanitized-css':
                            lang = 'css';
                            break;
                        case 'javascript':
                        case 'json':
                            lang = 'javascript';
                            break;
                        case 'Scribunto':
                            lang = 'lua';
                            break;
                        case 'wikitext':
                            lang = wgNamespaceNumber === 274 ? 'html' : 'mediawiki';
                            break;
                    }
                }
                const cm = await CodeMirror.fromTextArea(e.target, lang);
                void cm.defaultLint(true);
            })();
        }
    });
    Object.assign(window, { CodeMirror });
})();
